/**********************************************************
*                                                         *
* (c) 2008 - 2011 LnK                                     *
*                                                         *
* LnKSLIMbusScriptBuilder_IF.dll                          *
* Version 1.0                                             *
*                                                         *
* TestScriptbuilderDllDlg.cpp							  *
*                                                         *
* Date 12 March 2011                                      *
*                                                         *
* Johan Klewais                                           *
*                                                         *
* www.lnk-tools.com - info@lnk-tools.com                  *
*                                                         *
**********************************************************/

#include "stdafx.h"
#include "TestScriptbuilderDll.h"
#include "TestScriptbuilderDllDlg.h"
#include "LnKSLIMbusScriptBuilder_IF.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



char * errortxt[] = 
{
"LNK_SCRIPTBUILDER_OK",
"LNK_SCRIPTBUILDER_NOT_FOUND",
"LNK_SCRIPTBUILDER_ACTION_NOT_ALLOWED",
"LNK_SCRIPTBUILDER_FILE_WRITE_ERROR",
"LNK_SCRIPTBUILDER_FILE_READ_ERROR",
"LNK_SCRIPTBUILDER_XML_TRANSLATION_ERROR",
"LNK_SCRIPTBUILDER_COMMAND_BUSY",
"LNK_SCRIPTBUILDER_INVALID_VALUE"
};




/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestScriptbuilderDllDlg dialog

CTestScriptbuilderDllDlg::CTestScriptbuilderDllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestScriptbuilderDllDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestScriptbuilderDllDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestScriptbuilderDllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestScriptbuilderDllDlg)
	DDX_Control(pDX, IDC_E_LA, m_LA);
	DDX_Control(pDX, IDC_E_LOG, m_Log);
	DDX_Control(pDX, IDC_E_FILESAVE, m_FileSave);
	DDX_Control(pDX, IDC_E_FIEXMLEXPORT, m_FileXMLExport);
	DDX_Control(pDX, IDC_E_FILEAPPEND, m_FileAppend);
	DDX_Control(pDX, IDC_E_FILECSVIMPORT, m_FileCSVImport);
	DDX_Control(pDX, IDC_E_FILELOAD, m_FileLoad);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestScriptbuilderDllDlg, CDialog)
	//{{AFX_MSG_MAP(CTestScriptbuilderDllDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_B_OPEN, OnBOpen)
	ON_BN_CLICKED(IDC_B_FILELOAD, OnBFileload)
	ON_BN_CLICKED(IDC_B_FILESAVE, OnBFilesave)
	ON_BN_CLICKED(IDC_B_FILEAPPEND, OnBFileappend)
	ON_BN_CLICKED(IDC_B_FILECSVIMPORT, OnBFilecsvimport)
	ON_BN_CLICKED(IDC_B_FILEXMLEXPORT, OnBFilexmlexport)
	ON_BN_CLICKED(IDC_B_FILECLEARALL, OnBFileclearall)
	ON_BN_CLICKED(IDC_B_DLLVER, OnBDllver)
	ON_BN_CLICKED(IDC_B_SWVER, OnBSwver)
	ON_BN_CLICKED(IDC_B_CLOSE, OnBClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestScriptbuilderDllDlg message handlers

BOOL CTestScriptbuilderDllDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}


	m_FileLoad.SetWindowText("C:\\sba\\Scripts\\testload.lst");
	m_FileSave.SetWindowText("C:\\sba\\Scripts\\testsave.lst");
	m_FileAppend.SetWindowText("C:\\sba\\Scripts\\testappend.lst");
	m_FileXMLExport.SetWindowText("C:\\sba\\Scripts\\testxml.xml");
	m_FileCSVImport.SetWindowText("C:\\sba\\Scripts\\testcsv.csv");






	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestScriptbuilderDllDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestScriptbuilderDllDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestScriptbuilderDllDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestScriptbuilderDllDlg::OnBOpen() 
{
	int status;
	char buf[255];

	m_Log.SetWindowText("Opening ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusSBOpen();

	if( status >= 0 )
	{

		sprintf( buf,"Open = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"Open - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Open - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestScriptbuilderDllDlg::OnBClose() 
{
	int status;
	char buf[255];

	m_Log.SetWindowText("Closing ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusSBClose();

	if( status >= 0 )
	{

		sprintf( buf,"Close = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"Close - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Close - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestScriptbuilderDllDlg::OnBDllver() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusSBGetDLLVersion();

	if( status >= 0 )
	{

		sprintf( buf,"DLL software version = %d.%02d", status/0x100, status%0x100 );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"GetDLLVersion - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetDLLVersion - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestScriptbuilderDllDlg::OnBSwver() 
{
	int status;
	char buf[255];

	m_Log.SetWindowText("Getting Scriptbuilder SW version ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusSBGetSWVersion();

	if( status >= 0 )
	{

		sprintf( buf,"LnK ScriptBuilder software version = %02x.%02x.%02x", (status&0xff0000)>>16, (status&0xff00)>>8, status &0xff);
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"GetSWVersion - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetSWVersion - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestScriptbuilderDllDlg::OnBFileclearall() 
{
	int status;
	char buf[255];


	m_Log.SetWindowText("Clearing All ....");
	m_Log.UpdateWindow();

	
	status = LnKSLIMbusSBFileClearAll();

	if( status >= 0 )
	{

		sprintf( buf,"Clear All = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"Clear All - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Clear All - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestScriptbuilderDllDlg::OnBFileload() 
{
	CString filename;
	int status;
	char buf[255];

	m_FileLoad.GetWindowText( filename );

	sprintf( buf, "Loading [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusSBFileLoad( buf );

	if( status >= 0 )
	{

		sprintf( buf,"Fileload %s = %d", filename, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"Fileload - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Fileload - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestScriptbuilderDllDlg::OnBFilesave() 
{
	CString filename;
	int status;
	char buf[255];

	m_FileSave.GetWindowText( filename );

	sprintf( buf, "Saving [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusSBFileSave( buf );

	if( status >= 0 )
	{

		sprintf( buf,"FileSave %s = %d", filename, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"FileSave - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"FileSave - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestScriptbuilderDllDlg::OnBFileappend() 
{
	CString filename;
	int status;
	char buf[255];

	m_FileAppend.GetWindowText( filename );

	sprintf( buf, "Append [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusSBFileAppend( buf );

	if( status >= 0 )
	{

		sprintf( buf,"FileAppend %s = %d", filename, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"FileAppend - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"FileAppend - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestScriptbuilderDllDlg::OnBFilecsvimport() 
{
	CString filename;
	CString la;
	int		status;
	char	buf[255];
	int		ila = 0;

	m_FileCSVImport.GetWindowText( filename );
	m_LA.GetWindowText( la );
	ila = atoi(la);

	sprintf( buf, "CSV Import [%s] Logical Address %d  .....", filename, ila);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusSBFileCSVImport( buf, ila );

	if( status >= 0 )
	{

		sprintf( buf,"CSVImport %s, la= %d => %d", filename, ila, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"CSVImport - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"CSVImport - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestScriptbuilderDllDlg::OnBFilexmlexport() 
{
	CString filename;
	int status;
	char buf[255];

	m_FileXMLExport.GetWindowText( filename );

	sprintf( buf, "XML Export [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusSBFileXMLExport( buf );

	if( status >= 0 )
	{

		sprintf( buf,"XMLExport %s = %d", filename, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SCRIPTBUILDER_ERROR_LAST))
		{
			sprintf( buf,"XMLExport - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"XMLExport - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

